if not TCBR then
	TCBR = {}
end

local loaded=false
local context = UI.CreateContext("TCBR")
local config = UI.CreateFrame("RiftWindow", "XXX", context)
TCBR = config
local cfgvalues
TCBR.cfgvalues = cfgvalues
config:SetVisible(false)

local colkey
local addonName
local addonTable

function TCBR.Show(addon)
	addonName = addon
	config:SetTitle(addon.." Configuration")
	config:SetVisible(true)
	if addon == "TCB" then
		cfgvalues = TCB_Settings
		addonTable = _targetcastbar
		addonName = addon
	else
		cfgvalues = CBR_Settings
		config.checkboxBU:SetVisible(false)
		config.textBU:SetVisible(false)
		config.checkboxTU:SetVisible(false)
		config.textTU:SetVisible(false)

	end
	addonTable.configMode = true
	if cfgvalues.details == "" or cfgvalues.details == "t" or cfgvalues.details == "rt" then
		config.checkboxT:SetChecked(true)
	else
		config.checkboxT:SetChecked(false)
	end
	
	if cfgvalues.details == "" or cfgvalues.details == "r" or cfgvalues.details == "rt" then
		config.checkboxR:SetChecked(true)
	else
		config.checkboxR:SetChecked(false)
	end
	
	if cfgvalues.nl == 1 then
		config.checkboxNL:SetChecked(true)
	else
		config.checkboxNL:SetChecked(false)
	end
	
	config.checkboxBI:SetChecked(true)
end


config:SetPoint("CENTER", UIParent, "CENTER")
config:SetWidth(420)
config:SetHeight(500)

config.sliderR = UI.CreateFrame("RiftSlider", "SliderR", config)
config.sliderR:SetWidth(250)
config.sliderR:SetHeight(20)
config.sliderR:SetPoint("TOPLEFT", config, "TOPLEFT", 40,120)
config.sliderR:SetBackgroundColor(1,0,0,0.25)
config.sliderR:SetRange(0,255)

config.textR = UI.CreateFrame("Text", "TextR", config)
config.textR:SetWidth(30)
config.textR:SetHeight(20)
config.textR:SetLayer(1)
config.textR:SetBackgroundColor(1,0,0,0)
config.textR:SetFontColor(1,1,1)
config.textR:SetPoint("TOPLEFT", config.sliderR, "TOPRIGHT", 10,-7)

function config.sliderR.Event:SliderChange()
	local t = config.sliderR:GetPosition()
	config.textR:SetText(""..t)
	cfgvalues.cols[colkey.."_r"] = (t/255)
end

config.sliderG = UI.CreateFrame("RiftSlider", "SliderR", config)
config.sliderG:SetWidth(250)
config.sliderG:SetHeight(20)
config.sliderG:SetPoint("TOPLEFT", config, "TOPLEFT", 40,150)
config.sliderG:SetBackgroundColor(0,1,0,0.25)
config.sliderG:SetRange(0,255)

config.textG = UI.CreateFrame("Text", "TextR", config)
config.textG:SetWidth(30)
config.textG:SetHeight(20)
config.textG:SetLayer(1)
config.textG:SetBackgroundColor(1,0,0,0)
config.textG:SetFontColor(1,1,1)
config.textG:SetPoint("TOPLEFT", config.sliderG, "TOPRIGHT", 10,-7)

function config.sliderG.Event:SliderChange()
	local t = config.sliderG:GetPosition()
	config.textG:SetText(""..t)
	cfgvalues.cols[colkey.."_g"] = (t/255)
end

config.sliderB = UI.CreateFrame("RiftSlider", "SliderR", config)
config.sliderB:SetWidth(250)
config.sliderB:SetHeight(20)
config.sliderB:SetPoint("TOPLEFT", config, "TOPLEFT", 40,180)
config.sliderB:SetBackgroundColor(0,0,1,0.25)
config.sliderB:SetRange(0,255)

config.textB = UI.CreateFrame("Text", "TextR", config)
config.textB:SetWidth(30)
config.textB:SetHeight(20)
config.textB:SetLayer(1)
config.textB:SetBackgroundColor(1,0,0,0)
config.textB:SetFontColor(1,1,1)
config.textB:SetPoint("TOPLEFT", config.sliderB, "TOPRIGHT", 10,-7)

function config.sliderB.Event:SliderChange()
	local t = config.sliderB:GetPosition()
	config.textB:SetText(""..t)
	print("Setting cols["..colkey.."_b".."] to "..t)
	cfgvalues.cols[colkey.."_b"] = (t/255)
end

config.sliderA = UI.CreateFrame("RiftSlider", "SliderR", config)
config.sliderA:SetWidth(250)
config.sliderA:SetHeight(20)
config.sliderA:SetPoint("TOPLEFT", config, "TOPLEFT", 40,210)
config.sliderA:SetBackgroundColor(1,1,1,0.25)
config.sliderA:SetRange(0,100)

config.textA = UI.CreateFrame("Text", "TextR", config)
config.textA:SetWidth(30)
config.textA:SetHeight(20)
config.textA:SetLayer(1)
config.textA:SetBackgroundColor(1,0,0,0)
config.textA:SetFontColor(1,1,1)
config.textA:SetPoint("TOPLEFT", config.sliderA, "TOPRIGHT", 10,-7)

function config.sliderA.Event:SliderChange()
	local t = config.sliderA:GetPosition()
	config.textA:SetText(""..t)
	cfgvalues.alpha[colkey] = (t/100)
end

config.checkboxBI = UI.CreateFrame("RiftCheckbox", "cbBI", config)
config.checkboxBI:SetWidth(20)
config.checkboxBI:SetHeight(20)
config.checkboxBI:SetPoint("TOPLEFT", config, "TOPLEFT", 20,60)

local function SetSliders(r,g,b)
	r=math.floor(r*255)
	g=math.floor(g*255)
	b=math.floor(b*255)
	if not loaded then
		return
	end
	config.sliderR:SetPosition(r)
	config.sliderG:SetPosition(g)
	config.sliderB:SetPosition(b)
end

function config.checkboxBI.Event:CheckboxChange()
	if config.checkboxBI:GetChecked() then
		config.checkboxTI:SetChecked(false)
		config.checkboxBU:SetChecked(false)
		config.checkboxTU:SetChecked(false)
		local c = cfgvalues.cols
		colkey="bi"
		addonTable.configModeBar = "INT"
		SetSliders(c.bi_r,c.bi_g,c.bi_b)
	end
end

config.textBI = UI.CreateFrame("Text", "txtBI", config)
config.textBI:SetHeight(20)
config.textBI:SetWidth(120)
config.textBI:SetPoint("TOPLEFT", config, "TOPLEFT", 45,60)
config.textBI:SetText("Interruptible bar color")

config.checkboxTI = UI.CreateFrame("RiftCheckbox", "cbTI", config)
config.checkboxTI:SetWidth(20)
config.checkboxTI:SetHeight(20)
config.checkboxTI:SetPoint("TOPLEFT", config, "TOPLEFT", 20,85)

function config.checkboxTI.Event:CheckboxChange()
	if config.checkboxTI:GetChecked() then
		config.checkboxBI:SetChecked(false)
		config.checkboxBU:SetChecked(false)
		config.checkboxTU:SetChecked(false)
		local c = cfgvalues.cols
		colkey="ti"
		addonTable.configModeBar = "INT"
		SetSliders(c.ti_r,c.ti_g,c.ti_b)
	end
end

config.textTI = UI.CreateFrame("Text", "txtBI", config)
config.textTI:SetHeight(20)
config.textTI:SetWidth(120)
config.textTI:SetPoint("TOPLEFT", config, "TOPLEFT", 45,85)
config.textTI:SetText("Interruptible text color")

config.checkboxBU = UI.CreateFrame("RiftCheckbox", "cbBU", config)
config.checkboxBU:SetWidth(20)
config.checkboxBU:SetHeight(20)
config.checkboxBU:SetPoint("TOPLEFT", config, "TOPLEFT", 190,60)

function config.checkboxBU.Event:CheckboxChange()
	if config.checkboxBU:GetChecked() then
		config.checkboxTI:SetChecked(false)
		config.checkboxBI:SetChecked(false)
		config.checkboxTU:SetChecked(false)
		local c = cfgvalues.cols
		colkey="bu"
		addonTable.configModeBar = "UNT"
		SetSliders(c.bu_r,c.bu_g,c.bu_b)
	end
end

config.textBU = UI.CreateFrame("Text", "txtBU", config)
config.textBU:SetHeight(20)
config.textBU:SetWidth(120)
config.textBU:SetPoint("TOPLEFT", config, "TOPLEFT", 215,60)
config.textBU:SetText("Non-Interruptible bar color")

config.checkboxTU = UI.CreateFrame("RiftCheckbox", "cbTU", config)
config.checkboxTU:SetWidth(20)
config.checkboxTU:SetHeight(20)
config.checkboxTU:SetPoint("TOPLEFT", config, "TOPLEFT", 190,85)

function config.checkboxTU.Event:CheckboxChange()
	if config.checkboxTU:GetChecked() then
		config.checkboxTI:SetChecked(false)
		config.checkboxBU:SetChecked(false)
		config.checkboxBI:SetChecked(false)
		local c = cfgvalues.cols
		colkey="tu"
		addonTable.configModeBar = "UNT"
		SetSliders(c.tu_r,c.tu_g,c.tu_b)
	end
end

config.textTU = UI.CreateFrame("Text", "txtTU", config)
config.textTU:SetHeight(20)
config.textTU:SetWidth(120)
config.textTU:SetPoint("TOPLEFT", config, "TOPLEFT", 215,85)
config.textTU:SetText("Non-Interruptible text color")

config.checkboxT = UI.CreateFrame("RiftCheckbox", "cbT", config)
config.checkboxT:SetWidth(20)
config.checkboxT:SetHeight(20)
config.checkboxT:SetPoint("TOPLEFT", config, "TOPLEFT", 20,300)

config.textT = UI.CreateFrame("Text", "txtT", config)
config.textT:SetHeight(20)
config.textT:SetWidth(120)
config.textT:SetPoint("TOPLEFT", config, "TOPLEFT", 45,300)
config.textT:SetText("Show total time")

config.checkboxR = UI.CreateFrame("RiftCheckbox", "cbT", config)
config.checkboxR:SetWidth(20)
config.checkboxR:SetHeight(20)
config.checkboxR:SetPoint("TOPLEFT", config, "TOPLEFT", 20,325)

config.textRm = UI.CreateFrame("Text", "txtRm", config)
config.textRm:SetHeight(20)
config.textRm:SetWidth(120)
config.textRm:SetPoint("TOPLEFT", config, "TOPLEFT", 45,325)
config.textRm:SetText("Show remaining time")

config.checkboxNL = UI.CreateFrame("RiftCheckbox", "cbNL", config)
config.checkboxNL:SetWidth(20)
config.checkboxNL:SetHeight(20)
config.checkboxNL:SetPoint("TOPLEFT", config, "TOPLEFT", 20,360)

config.textNL = UI.CreateFrame("Text", "txtNL", config)
config.textNL:SetHeight(20)
config.textNL:SetWidth(120)
config.textNL:SetPoint("TOPLEFT", config, "TOPLEFT", 45,360)
config.textNL:SetText("Show text on single line")

---
loaded=true
--TCBR.Show("TCB")
